function Xaxis(cs,applet_width,options)
//Draws an xaxis in coordinate system cs with defining points at the edges of the applet window
{var P, Q, h, _0, O, x, v1, v2
P=FixedPoint(0,0,'hidden')
Q=FixedPoint(applet_width,0,'hidden')
h=Line(Q,P,'hidden')
_0=Calculate(0,0,'','0!',[h],'hidden')
O=PlotXY(_0,cs,_0,'hidden')
x=Parallel(h,O,'hidden')
v1=Perpendicular(x,P,'hidden')
v2=Perpendicular(x,Q,'hidden')
X_l=Intersect(x,v1,'hidden')
X_r=Intersect(x,v2,'hidden')
return Line(X_r,X_l,options)
}

function LabelPoint(point,label,options)
{var txt=FixedText(0,0,label,'hidden')
var pos=options.indexOf('size(')
var size='10'
if (pos>=0) {size=options.substr(pos+5,2)}
size=size.replace(')','')
size=eval(size)
var horizontal=Math.round(-6+(16-size)/2)
var vertical=Math.round(-3-(size-10)/2)
if (options.indexOf('justifyLeft')>=0 || options.indexOf('justify')==-1)
{horizontal+=14
options=options.replace('justifyLeft,','')
options=options.replace(',justifyLeft','')
options=options.replace('justifyLeft','')}
if (options.indexOf('justifyRight')>=0)
{horizontal-=14
options=options.replace('justifyRight,','')
options=options.replace(',justifyRight','')
options=options.replace('justifyRight','')}
if (options.indexOf('justifyTop')>=0)
{vertical-=12
options=options.replace('justifyTop,','')
options=options.replace(',justifyTop','')
options=options.replace('justifyTop','')}
if (options.indexOf('justifyBottom')>=0)
{vertical+=12
options=options.replace('justifyBottom,','')
options=options.replace(',justifyBottom','')
options=options.replace('justifyBottom','')}
var H=Translation(point,horizontal,vertical,'hidden')
PeggedText(H,txt,options)
}

function LabelCs(cs,options)
//Labels a coordinate system cs
{var H1=Point(0,0,"hidden")
var H2=Point(5,0,"hidden")
var r=Segment(H2,H1,"hidden")
var _0=Calculate(0,0,'','0!',[r],'hidden')
var _1=Calculate(0,0,'','1!!',[r],'hidden')
var O=PlotXY(_0,cs,_0,'hidden')
var UP_x=PlotXY(_0,cs,_1,'hidden')
Circle_by_radius(O,r,options)
var T=FixedText(0,0,'1',"hidden")
var U=Translation(UP_x,-3,-16,'hidden')
PeggedText(U,T,options)
var UP_y=PlotXY(_1,cs,_0,'hidden')
var V=Translation(UP_y,-12,-5,'hidden')
PeggedText(V,T,options)
}

function LabelSegment(segment,text,options)
//Labels a segment a by the text c
{var M=Midpoint(segment,'hidden')
var H1=FixedPoint(0,0,'hidden')
var H2=FixedPoint(10,0,'hidden')
var h=Segment(H2,H1,'hidden')
var c=Circle_by_radius(M,h,'hidden')
var H=Intersect2(segment,c,'hidden')
var H_rot=Rotation(H,M,1.57,'hidden')
var H_trans=Translation(H_rot,0,-5,'hidden')
var txt=FixedText(0,0,text,'hidden')
return PeggedText(H_trans,txt,'justifyCenter,'+options)
}

function SketchedSegment(a,b,style,n,options)
{var k
if (style==0) {k=n+1}
if (style==1) {k=2*n-1}
if (style==2) {k=3*n-2}
var H=Dilation(b,a,1/k,'hidden')
var P,Q,U,V
P=a
for (var i=0; i<n-1; i++){
Q=P
if (style!=0) {
  Q=VectorTranslation(P,a,H,'hidden')
  Segment(Q,P,options) }
P=VectorTranslation(Q,a,H,'hidden')
if (style!=1) {
  V=P
  U=UnitPoint(P,1,'hidden')
  if (options.indexOf('thick')>=0) {V=Dilation(U,P,-1,'hidden')}
  Segment(U,V,options)}
if (style==2) P=VectorTranslation(P,a,H,'hidden') }
if (style==0) {P=VectorTranslation(P,a,H,'hidden')
  V=P
  U=UnitPoint(P,1,'hidden')
  if (options.indexOf('thick')>=0) {V=Dilation(U,P,-1,'hidden')}
  Segment(U,V,options)}
else Segment(b,P,options)
}

function PerpendicularBisector(a,b,options)//Draws Perpendicular Bisector of points a,b 
{var X,Y;
X=Segment(a,b,'[hidden]')
Y=Midpoint(X,'[hidden]')
return Perpendicular(X,Y,options)
}

function SketchedCircle(a,b,style,n,options)
{var k
if (style==0) {k=n+1}
if (style==1) {k=2*n}
if (style==2) {k=3*n}
var s=Segment(b,a,'hidden')
var P,Q,U,V
P=b
for (var i=0; i<n; i++){
Q=P
if (style!=0) {
  Q=Rotation(P,a,2*Math.PI/k,'hidden')
  Arc(M,P,Q,s,options) }
P=Rotation(Q,a,2*Math.PI/k,'hidden')
if (style!=1) {
  V=P
  U=UnitPoint(P,1,'hidden')
  if ((style==0) && (options.indexOf('thick')>=0)) {V=Dilation(U,P,-1,'hidden')}
  Segment(U,V,options)}
if (style==2) P=Rotation(P,a,2*Math.PI/k,'hidden') }
}

function Circle3Points(a,b,c,options)
//Draws a circle through the points a,b and c
{var h='[hidden]';
var b1=PerpendicularBisector(a,b,h)
var b2=PerpendicularBisector(a,c,h)
var s=Intersect(b1,b2,h)
return Circle(s,a,options)
}

function Vector(foot,tail,caption,options)//Draws a labeled vector with foot and tail
{var hyphen=''
var size=16
if (options>'') hyphen=','
var str=''
var pos=options.lastIndexOf('size(') 
if (pos>=0) {pos=pos+5
while (options.charCodeAt(pos)>=48 && options.charCodeAt(pos)<=57)
{str=str+options.charAt(pos); pos++}
size=eval(str)}
var style='justifyCenter,size(16)'
var reg = new RegExp("thick","")
if (reg.test(options)) style+=',bold'
var s=Segment(tail,foot,options)
var U_F=UnitPoint(foot,50,'hidden')
var arc_F=Angle(U_F,foot,tail,0,0,'','hidden')
var F=TranslationMarkedAngleFixedDistance(foot,arc_F,6,'hidden')
var F1=Rotation(F,foot,1.5708,'hidden')
var F2=Reflection(F1,s,'hidden')
Segment(F2,F1,options)
var U_T=UnitPoint(tail,50,'hidden')
var arc_T=Angle(U_T,tail,foot,0,0,'','hidden')
var T=TranslationMarkedAngleFixedDistance(tail,arc_T,9,'hidden')
var T1=Rotation(T,tail,0.5,'hidden')
var T2=Reflection(T1,s,'hidden')
Segment(T1,tail,options)
Segment(T2,tail,options)
var M=Midpoint(s,'hidden')
var M1=VectorTranslation(F1,foot,M,'hidden')
if (caption>''){
var txt=FixedText(0,0,caption,'hidden')
PeggedText(M1,txt,style+hyphen+options)
var M2=Translation(M1,Math.round(-size*0.2)-1,size,'hidden')
var M3=UnitPoint(M2,Math.round(size*0.4),'hidden')
var type=options
var reg = new RegExp("thick","g")
var newtype = type.replace(reg,"")
type=newtype
reg = new RegExp(",,","g");
newtype = type.replace(reg,",");
type=newtype
reg = new RegExp("(^,)|(,$)","g");
newtype = type.replace(reg,"");
var newhyphen=''
if (newtype>'') newhyphen=','
Segment(M3,M2,newtype)
var arr=FixedText(0,0,'>','hidden')
var M4=Translation(M3,-2,-4,'hidden')
PeggedText(M4,arr,newtype+newhyphen+"font('Helvetica'),size(10)")}
return M1
}

function AngleBisector(a,vertex,c,options)//Draws Angular Bisector of angle a-vertex-c
{var h='[hidden]'
var circle=Circle(vertex,a,h)
var va=Ray(a,vertex,h)
var vc=Ray(c,vertex,h)
var s2=Intersect2(vc,circle,h)
var seg=Segment(a,s2,h)
var m=Midpoint(seg,h)
return Ray(m,vertex,options)
}

function AngleBisector2(a,vertex,c,options)//Draws second Angular Bisector of angle a-vertex-c
{var h='[hidden]'
var circle=Circle(vertex,a,h)
var va=Line(a,vertex,h)
var vc=Line(c,vertex,h)
var s1=Intersect1(va,circle,h)
var s2=Intersect1(vc,circle,h)
var seg=Segment(s1,s2,h)
var m=Midpoint(seg,h)
return Ray(m,vertex,options)
}

function MarkAngle(A,S,B,r,n,txt,opt_legs,opt_sector,opt_arc,opt_txt) {
var acc_sector = ','
var acc_txt = ','
if (opt_sector == '') acc_sector = ''
if (opt_txt == '') acc_txt = ''
var s1 = Ray(A,S,opt_legs)
var s2 = Ray(B,S,opt_legs)
var kS = Circle_by_radius(S,r,'hidden')
var S1 = Intersect2(s1,kS,'hidden')
var S2 = Intersect2(s2,kS,'hidden')
var rad=Angle(A,S,B,10,10,'','hidden')
rad=Calculate(10,30,'',Math.PI+' 2*A+',[rad],'hidden')
rad=Calculate(10,50,'','AA2 '+Math.PI+'*/@trnc2*'+Math.PI+'*-',[rad],'hidden')
var rad_n=Calculate(10,50,'','A'+n+'/',[rad],'hidden')
var S_ = new Array(n+2)
S_[0] = S1
for (var i=1; i<n; i++)
{S_[i] = RotationMeasuredAngle(S_[i-1],S,rad_n,'hidden')
Segment(S_[i],S_[i-1],opt_arc)}
S_[n] = S2
Segment(S_[n],S_[n-1],opt_arc)
S_[n+1] = S
Polygon(S_,'layer(1)'+acc_sector+opt_sector)
var rad_2=Calculate(10,50,'','A2/',[rad],'hidden')
var S_2=RotationMeasuredAngle(S1,S,rad_2,'hidden')
var M=Dilation(S_2,S,0.6,'hidden')
var T = FixedText(0,0,txt,'hidden')
PeggedText(M,T,'justifyCenter'+acc_txt+opt_txt)
}

function Barycenter(a,b,c,options) //Constructs the barycenter of a triangle
{var s_ab=Segment(a,b,'hidden')
var M_ab=Midpoint(s_ab,'hidden')
var h_ab=Line(M_ab,c,'hidden')
var s_ac=Segment(a,c,'hidden')
var M_ac=Midpoint(s_ac,'hidden')
var h_ac=Line(M_ac,b,'hidden')
return Intersect(h_ab,h_ac,options)
}

function InscribedCircle(a,b,c,options)//Draws inscibed circle of points a, b and c
{var h='[hidden]'
var b1=AngleBisector(a,b,c,h)
var b2=AngleBisector(a,c,b,h)
var s=Intersect(b1,b2,h)
var seg=Segment(a,b,h)
var p=Perpendicular(seg,s,h)
var l=Intersect(p,seg,h)
return Circle(s,l,options)
}

function Arc(vertex,startpoint,endpoint,radius,options)//Arc with a radius equal to that of Segment radius, with startpoint and endpoint defining the "rays";the arclength is allways less than or equal to 180 degres
{var h='[hidden]'
var c=Circle_by_radius(vertex,radius,'hidden')
var ray1=Ray(startpoint,vertex,h)
var ray2=Ray(endpoint,vertex,h)
var s1=Intersect2(ray1,c,h)
var s2=Intersect2(ray2,c,h)
var seg=Segment(s1,s2,h)
var m=Midpoint(seg,h)
var ppb=Ray(vertex,m,h)
var P=Intersect2(ppb,c,h)
var Q=Point_on_object(seg,0.1,h)
var ray3=Ray(Q,P,h)
var A=Intersect2(ray3,c,h)
return Locus(A,Q,seg,200,options)
}

function Arc2(vertex,startpoint,endpoint,radius,options)//Arc with a radius equal to that of Segment radius, with startpoint and endpoint defining the "rays";the arclength is allways more than or equal to 180 degres
{var h='[hidden]'
var c=Circle_by_radius(vertex,radius,'hidden')
var ray1=Ray(startpoint,vertex,h)
var ray2=Ray(endpoint,vertex,h)
var s1=Intersect2(ray1,c,h)
var s2=Intersect2(ray2,c,h)
var seg=Segment(s1,s2,h)
var m=Midpoint(seg,h)
var ppb=Ray(m,vertex,h)
var P=Intersect2(ppb,c,h)
var Q=Point_on_object(seg,0.1,h)
var ray3=Ray(Q,P,h)
var A=Intersect2(ray3,c,h)
return Locus(A,Q,seg,200,options)
}

function Sector(a,b,angle,edge_options,fill_options)
/*Constructs 51 vertices of a polygon with centre a as first and b as second vertex and measured sector angle*/
{var num=50
var points=new Array(num+1)
var w=Calculate(0,0,'','A'+String(num)+' 1-/',[angle],'hidden')
points[0]=a
points[1]=b
Segment(points[1],points[0],edge_options)
for(var i=2;i<num+1;i++){
points[i]=RotationMeasuredAngle(points[i-1],a,w,'hidden')
Segment(points[i],points[i-1],edge_options)}
Segment(points[0],points[num],edge_options)
return Polygon(points,fill_options)
}

function Parabola(focus,directrix,options)//Draws Parabola given focus and directrix
{var e,g,h,p
e=Point_on_object(directrix,0.2,'[hidden]')
p=Perpendicular(directrix,e,'[hidden]')
g=PerpendicularBisector(focus,e,'[hidden]')
h=Intersect(p,g,'[hidden]')
return Locus(h,e,directrix,200,options)
}

function Ellipse_Hyperbola(focus1,focus2,radius_directrix,options)//Draws Ellipse/Hyperbola with foci focus1 and focus2, whose directrix is a circle with centre focus1 and radius given by the length of segment radius_directrix.
 {var e,g,h,p
var directrix=Circle_by_radius(focus1,radius_directrix,'[hidden]')
e=Point_on_object(directrix,0,'[hidden]')
p=Ray(e,focus1,'[hidden]')
g=PerpendicularBisector(focus2,e,'[hidden')
h=Intersect(p,g,'[hidden]')
return Locus(h,e,directrix,200,options)
}

function Bezier(a,options)
//Constructs a bezier curve. List a contains the points. The curve starts and ends at the first and last point. All other points are guide points. Options contains the options of the curve. Bezier returns an array with two elements. The first element (with index zero) refers to the curve itself. The second element (index 1) is an array that contains the construction. This array can be handed to action buttons. 
{
function bezier2(head,tail){
points[1][points[1].length]=Segment(head,tail,h)
var pp=DilationMarkedRatio(head,tail,r,h)
points[1][points[1].length]=pp
return pp
}
function bezierx(a){
if (a.length==2) {return bezier2(a[0],a[1])} else {
var k=new Array()
for (var i=0;i<a.length-1;i++)
{k[i]=bezier2(a[i],a[i+1])}
return bezierx(k)}
}
h='hidden'
construction+='{Start Bezier}\n'
points=new Array()
points[1]=new Array()
var s1=Segment(a[0],a[1],h)
points[1][0]=s1
var p=Point_on_object(s1,0.6,h+',red,layer(1000)')
points[1][1]=p
var r=RatioPoints(a[1],a[0],p,10,10,'r=',h)
var l=bezierx(a)
points[0]=Locus(l,p,s1,200,options)
construction+='{end bezier}\n'
return points
}

function cov(func)
{if (RegExp) {
re=/round/g
func=func.replace(re,'rond')
re=/[@_]/g
func=func.replace(re,'')
re=/trunc/g
func=func.replace(re,'truc')
re=/(sin|cos|tan|abs|sgn|log)/g
func=func.replace(re,'@$1_')
re=/ln/g
func=func.replace(re,'@ln__')
re=/(sqrt|asin|acos|atan|rond|truc)/g
func=func.replace(re,'@$1;')
var re=/([a-z])([^a-z_;])/g
func=func.replace(re,'#A1 $2')
re=/;/g
func=func.replace(re,'')}
return func}

function GraphMeasured(origin,unit,myfunc,measurements,measvars,options)
{var func=checktekst(myfunc)
var characters='B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z'
characters=characters.split(',')
for (var i=0;i<measvars.length;i++)
{re=eval('/([^a-z_;])('+measvars[i]+')([^a-z_;])/g')
func=func.replace(re,' '+characters[i]+' ')}
func=cov(func)
var b=UnitPoint(origin,unit,'yellow,label(1)')
var c=OriginUnit(origin,b,'')
var xaxis=AxisX(c,'thick')
var yaxis=AxisY(c,'thick')
var X=Point_on_object(xaxis,0.6,'label(x)')
var x=Coordinates(X,c,30,30,'','hidden')
q=Calculate(10,10,myfunc,func,[x,measurements],'hidden')
p=Calculate(10,10,'','#A1',[x],'hidden')
pq=PlotXY(q,c,p,'')
Segment(X,pq,'')
coord=Coordinates(pq,c,10,10,'','hidden')
PeggedText(pq,coord,'size(11)')
FixedText(10,10,'Move x to trace','size(11)')
Locus(pq,X,xaxis,200,options)
}

function Graph(origin,unit_x,unit_y,applet_width,myfunc,options_cs,options_xy,options_gf)
{unit_point=UnitPoint(origin,unit_x,'yellow')
r_unit_point=RectangularUnitPoint(unit_point,unit_y,'yellow')
yaxis=VerticalAxis(origin,r_unit_point,options_xy)
var haxis=HorizontalAxis(origin,unit_point,options_xy)
cs=CoordSysByAxes(haxis,yaxis,options_cs)
LabelCs(cs,'size(12),bold,black')
xaxis=Xaxis(cs,applet_width,options_xy)
X=Point_on_object(xaxis,0.3,'label(x)')
var xy=Coordinates(X,cs,0,0,'','hidden')
var func=checktekst(myfunc)
func=cov(func)
var q=Calculate(10,10,myfunc,func,[xy],'hidden')
x=Calculate(10,10,'','#A1',[xy],'hidden')
var pq=PlotXY(q,cs,x,'')
Segment(X,pq,'')
var coord=Coordinates(pq,cs,10,10,'','hidden')
var coord_x=Calculate(0,0,'(','#A1',[coord],'hidden')
var coord_y=Calculate(0,0,' | ','#A2',[coord],"suffix(')'),hidden")
var coord_txt=ConcatText(0,0,[coord_x,coord_y],'hidden')
PeggedText(pq,coord_txt,'size(11)')
FixedText(10,10,'Move x to trace','size(11)')
Locus(pq,X,xaxis,200,options_gf)
}

function Graph2(origin,unit_x,unit_y,myfunc1,myfunc2,options_cs,options_xy,options_gf)
{unit_point=UnitPoint(origin,unit_x,'yellow')
r_unit_point=RectangularUnitPoint(unit_point,unit_y,'yellow')
yaxis=VerticalAxis(origin,r_unit_point,options_xy)
var haxis=HorizontalAxis(origin,unit_point,options_xy)
cs=CoordSysByAxes(haxis,yaxis,options_cs)
LabelCs(cs,'size(12),bold,black')
var P=FixedPoint(-1500,0,'hidden')
var Q=FixedPoint(1500,0,'hidden')
var h=Line(Q,P,'hidden')
var v1=Perpendicular(haxis,P,'hidden')
var v2=Perpendicular(haxis,Q,'hidden')
var X_l=Intersect(haxis,v1,'hidden')
var X_r=Intersect(haxis,v2,'hidden')
xaxis=Line(X_r,X_l,options_xy)
T=Point_on_object(xaxis,0.51,'label(t)')
var xy=Coordinates(T,cs,30,30,'','hidden')
var func1=checktekst(myfunc1)
func1=cov(func1)
var func2=checktekst(myfunc2)
func2=cov(func2)
var q=Calculate(10,10,'',func2,[xy],'hidden')
var p=Calculate(10,10,'',func1,[xy],'hidden')
var pq=PlotXY(q,cs,p,'')
var coord=Coordinates(pq,cs,10,10,'','hidden')
var coord_x=Calculate(10,10,'(','#A1',[coord],'hidden')
var coord_y=Calculate(10,10,' | ','#A2',[coord],"suffix(')'),hidden")
var coord_txt=ConcatText(100,200,[coord_x,coord_y],'hidden')
PeggedText(pq,coord_txt,'size(11)')
FixedText(10,10,'Move t to trace','size(11)')
Locus(pq,T,xaxis,1500,options_gf)
}

function Pie(a,centrex,centrey,radius,colors)
//draws a pie chart of array a with centre at (cetrex,centrey) with radius radius, colors is an array with color names
{var p=Point(centrex,centrey,'hidden')
var cl=colors.length
var q=Point(centrex+radius,centrey,'hidden')
var circle=Circle(p,q,'black')
var l=a.length
var cum=new Array()
var points=new Array()
cum[0]=0
for (var i=1;i<=l;i++) {cum[i]=cum[i-1]+a[i-1];FixedText(10,10*i+10,''+a[i-1],'size(12),'+colors[(i-1)%cl])}
for (var i=0;i<l;i++) {
var start=cum[i]/cum[l]
var end=cum[i+1]/cum[l]
//var number=Math.round((end-start)*400)
var number=(end-start)*400
points[0]=p;points.length=1
for (j=0;j<=number+1;j++){
points[j+1]=
Point_on_object(circle,Math.round((start+(j)/400)*2000*Math.PI)/1000,'hidden')}
points[points.length]=p
Polygon(points,colors[i%cl])
}
}